﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@model Toyota.Common.Web.MVC.ModelHolder
           
@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>

@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
        background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
        background-color: #DDECFF;
        border: 1px solid #94B6E8;
        color: #94B6E8;
        @*font-weight: bold;*@
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px; border:1px solid #6A8CCB;}
}


@section Script{
    $(document).ready(function() {
 
        $('#PO_MONTH_I').monthpicker({
            startYear: new Date().getFullYear() - 4,
            finalYear: new Date().getFullYear() + 4,
            pattern: 'mmm yyyy',
                monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
        });

        $('#PRMonth_I').bind('onchange',function(e){
            alert("input change");
        });  
    });
}




@section StartupScript{
    PO_MONTH.value = '';
}

<style type="text/css">
    #PO_MONTH_I, #PO_MONTH
    {
        background-color:#F6CECE!important;    
    }
    
    #PO_NO_I, #PO_NO,#PODate1_I,#PODate1,#PODate2_I,#PODate2,#PO_STATUS_I,#PO_STATUS
    {
        background-color:#F5F6CE!important;    
    }


</style>

<script type="text/javascript">

    $(document).ready(function () { 
            PODate1.SetText("");
            PODate2.SetText("");
            
            //modif July 11. 2014 - agung
            var month = new Array("January","February","March","April","May","June","July","August","September","October","November","December");
            var d = new Date()
            var get_month = d.getMonth()+1;
            var get_year = d.getFullYear();

            PO_MONTH.SetText(month[get_month]+" "+get_year);
            //end modif.....

            
            enabledButton();
            GridPO_STATUS.SetHeight(-98);

        $('#PO_NO_I').keypress(function(e){
            if(e.keyCode==8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40)
            {
            }
            else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9]/))
            {
                e.preventDefault();
            }
        });

        

    });

    var is_Bypass = false;
    function gridPOApproval_Init(s, e) {
        enabledButton();
        GridPOApporval.PerformCallback();
    }

    function OnBeginCallbackGrid(s, e) {
        e.customArgs["pPO_MONTH"] = GetProductionMonth(PO_MONTH.GetValue()) ;
        e.customArgs["pPO_NO"] = PO_NO.GetText();
        e.customArgs["pPODate1"] = PODate1.GetText();
        e.customArgs["pPODate2"] = PODate2.GetText();
        e.customArgs["pPO_STATUS"] = PO_STATUS.GetValue();

        disabledButton();
    }




    function OnEndCallbackGrid(s, e) {
        enabledButton();
    }

    function SearchData(s, e) {
        var result = false;
        var a = PO_NO.GetText();
        var err = 0;

        if(a.match(/[^A-Za-z0-9]/) != null){
            err = 1;
        }
        
        if (PO_MONTH.GetText() == '') {
            //MessageBox('Please select production month!','warning_icon.png','Warning',280);
            $.msgBox({ title: "Warning", type: "alert", content: "Please select PO Month", afterClose : enabledButton });
            disabledButton();
        }else

        if (PODate1.GetText() != '' && PODate2.GetText() == '') {
            //MessageBox('Please fill PO date!','warning_icon.png','Warning',205);
            $.msgBox({ title: "Warning", type: "alert", content: "Please fill PO date!", afterClose : enabledButton });
            disabledButton();
        }else

        if (PODate2.GetText() != '' && PODate1.GetText() == '') {
            //MessageBox('Please fill PO date!','warning_icon.png','Warning',205);
            $.msgBox({ title: "Warning", type: "alert", content: "Please fill PO date!", afterClose : enabledButton });
            disabledButton();
        }

        else {
           if ( PODate1.GetValue() > PODate2.GetValue() )
           {
                //MessageBox('PO date should not be greater than PO Date!','warning_icon.png','Warning',260);
                $.msgBox({ title: "Warning", type: "alert", content: "PO date from should not be greater than PO Date to!", afterClose : enabledButton });
           }else{
                    if(err == 1){
                        $.msgBox({ title: "Warning", type: "alert", content: "Only can be use number or text!"});
                    }else{
                        disabledButton();
                        GridPOApporval.ClearFilter();
                    }
                    err = 0;
           }
       }
    }


    var toggle = 1;
    function ShowDetail(s, e) {
      GridPOApporval.PerformCallback('ToggleColumns=RELEASE_DATE;PO_REJECT');
      if (toggle == 1){
            btnView.SetText("Hide Detail");
            $('#grid').attr("style", "width:100%");
            toggle = 0;
        }else{
            btnView.SetText("Show Detail");
            $('#grid').attr("style", "width:1142px");
            toggle = 1;
        }
    }

    function ClearGrid(){
        PO_STATUS.SetText("");
        PO_NO.SetText("");
        PODate1.SetText("");
        PODate2.SetText("");
        PO_MONTH.SetText("");
        GridPOApporval.ClearFilter();
        OrderSelectionLabel.SetValue("");

    }

    function enabledButton() {
        btnView.SetEnabled(true);
        btnRelease.SetEnabled(true);
        btnreject.SetEnabled(true);
        btnDownload.SetEnabled(true);
        POSearchButton.SetEnabled(true);
        btnClear.SetEnabled(true);
    }

    function disabledButton() {
        btnView.SetEnabled(false);
        btnRelease.SetEnabled(false);
        btnreject.SetEnabled(false);
        btnDownload.SetEnabled(false);
        POSearchButton.SetEnabled(false);
        btnClear.SetEnabled(false);
    }

    function MessageBox(s, e, headerText,width) {
        if (e != '') {
            msgboxicon.src = '/Content/Images/' + e;
        } else {

            msgboxicon.src = '';
        }
        msgboxcaption.SetText(s);
        msgbox.SetWidth(width);
        msgbox.SetHeaderText(headerText);
        msgbox.Show();
    }

//    function convertDate (param){
//        var param;

//        if (param == null){
//            yearmonthval = "";

//        }else{

//            var POmonthVal = param.toLocaleString();
//            //var d = new Date(POMonth.GetValue());
//            var d = new Date(POmonthVal);
//            var curr_month = d.getMonth() + 1 ;
//            var curr_year = d.getFullYear();
//            var n = String(curr_month).length;

//            if (n==1){
//                curr_month = '0'+curr_month;
//            }else{
//                curr_month= curr_month;
//            }

//            var yearmonthval = curr_year+''+curr_month;
//        }

//        return yearmonthval;
//    }


    function GetProductionMonth(productionMonth) {
         var paramStr = String(productionMonth).replace('-', '');
         var paramStrLength = String(paramStr).length;

         var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
         var month = String(paramStr).substring(0, paramStrLength - 5);
         var monthEnum = {
             January: '01',
             February: '02',
             March: '03',
             April: '04',
             May: '05',
             June: '06',
             July: '07',
             August: '08',
             September: '09',
             October: '10',
             November: '11',
             December: '12'
         };
         var monthNum = "";
         if (Boolean(month))
             monthNum = monthEnum[month];
          
         return year + monthNum;
     }

    function btnRelease_Click(s, e) {
        if(PO_MONTH.GetText()=="")
        {
            disabledButton();
             //MessageBox('Please select PO Month', '');
             $.msgBox({ title: "Warning", type: "alert", content: "Please select PO Month", afterClose : enabledButton });
                  
        }
        else if(GridPOApporval.GetSelectedKeysOnPage() == ""){
            disabledButton();
             //MessageBox('No data selected','warning_icon.png','Warning',210);
             $.msgBox({ title: "Warning", type: "alert", content: "No data selected", afterClose : enabledButton });
             
        }
        else
        {
            var valGrid = JSON.stringify(GridPOApporval.GetSelectedKeysOnPage());
                valGrid = valGrid.replace('["','');
                valGrid = valGrid.replace('"]',';');
                valGrid = valGrid.replace(/","/g,';');

            var pono = valGrid;
            performApproval(pono);
            //alert(pono);
        
        }
        
    }

    function btnreject_Click(s, e) {
        if(PO_MONTH.GetText()=="")
        {
            disabledButton();
             //MessageBox('Please select PO Month', '');
             $.msgBox({ title: "Warning", type: "alert", content: "Please select PO Month", afterClose : enabledButton });        
        }
        else if(GridPOApporval.GetSelectedKeysOnPage() == ""){
            disabledButton();
             //MessageBox('No data selected','warning_icon.png','Warning',210);
             $.msgBox({ title: "Warning", type: "alert", content: "No data selected", afterClose : enabledButton });        
        }
        else
        {
             var valGrid = JSON.stringify(GridPOApporval.GetSelectedKeysOnPage());
                valGrid = valGrid.replace('["','');
                valGrid = valGrid.replace('"]',';');
                valGrid = valGrid.replace(/","/g,';');

            var pono = valGrid;
            performReject(pono);
            //alert(pono);

        
        }

        

    }


    function performApproval (pono){
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/D31203/performApproval")",
            data: {
                //GridId : OrderSelectionLabel.GetValue().substring(0, (OrderSelectionLabel.GetValue().length-1)),
                PO_NO : pono              
            },
            success: function (result) {
                var resValue = result.split('|');
                if (resValue[0] == 'Sucess'){
                    //MessageBox(resValue[1],'info_icon.png','Information',220);
                    $.msgBox({ title: "info", type: "info", content: resValue[1], afterClose : enabledButton });      
                    disabledButton();
                    OrderSelectionLabel.SetValue('');
                    GridPOApporval.ClearFilter();
                    GridPOApporval.UnselectAllRowsOnPage();
                    enabledButton();
                }else
                {
                    //MessageBox(resValue[1],'error_icon.png','Error',220);
                    $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton });
                    GridPOApporval.ClearFilter();
                    GridPOApporval.UnselectAllRowsOnPage();
                    enabledButton();
                }
            },
            error: function (result) {
                var resValue = result.split('|');
                //MessageBox(resValue[1],'error_icon.png','Error',220);
                $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton });
                GridPOApporval.ClearFilter();
                GridPOApporval.UnselectAllRowsOnPage();
                enabledButton();
            }
        });
    }

    function performReject (pono){
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/D31203/performReject")",
            data: {
                //GridId : OrderSelectionLabel.GetValue().substring(0, (OrderSelectionLabel.GetValue().length-1)),
                PO_NO : pono                  
            },
            success: function (result) {
                var resValue = result.split('|');
                if (resValue[0] == 'Sucess'){
                    //MessageBox(resValue[1],'info_icon.png','Information',220);
                    $.msgBox({ title: "info", type: "info", content: resValue[1], afterClose : enabledButton });
                    disabledButton();
                    OrderSelectionLabel.SetValue('');
                    GridPOApporval.UnselectAllRowsOnPage();
                    //GridPurchaseRequest.UnselectRows();
                    GridPOApporval.ClearFilter();
                    enabledButton();
                }else
                {
                    //MessageBox(resValue[1],'error_icon.png','Error',190);
                    $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton });
                    disabledButton();
                    GridPOApporval.UnselectAllRowsOnPage();
                    GridPOApporval.ClearFilter();
                    enabledButton();
                }
            },
            error: function (result) {
 
                var resValue = result.split('|');
                //MessageBox(resValue[1],'error_icon.png','Error',190);
                $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton });
                disabledButton();
                GridPOApporval.UnselectAllRowsOnPage();
                GridPOApporval.ClearFilter();
                enabledButton();
            }
        });
    }

    //Download Excel------------------------------------------------------------------------------------------
    var IsDownload = "no";

    function DownloadData(s, e) {
    var a = PO_NO.GetText();
        var err = 0;

        if(a.match(/[^A-Za-z0-9]/) != null){
            err = 1;
        }

    var result = false;
        if(PO_MONTH.GetText() == '' && PODate1.GetText() == '' && PODate2.GetText() == '' && PO_NO.GetText() == '' && PO_STATUS.GetText() =='') {
            disabledButton();
            //MessageBox('Please fill one or all search parameter to download','warning_icon.png','Warning',280);
            $.msgBox({ title: "Warning", type: "alert", content: "Please fill one or all search parameter to download", afterClose : enabledButton });
        }
        
        else if(PO_MONTH.GetText() == ''){
            //MessageBox('Please select production month!','warning_icon.png','Warning',280);
            $.msgBox({ title: "Warning", type: "alert", content: "Please select production month!", afterClose : enabledButton });
            disabledButton();
        }
        else {
              if(err == 1){
                    $.msgBox({ title: "Warning", type: "alert", content: "Only can be use number or text!"});
              }else{
                    IsDownload = "yes";   
                    BeginCallbackDownload(s, e);
                    disabledButton();
              }
              err = 0;
            
       }        
    }

    function BeginCallbackDownload(s, e) {
        if(PO_MONTH.GetText() == '')
        {
            //MessageBox('Please select production month!','warning_icon.png','Warning',280);
            $.msgBox({ title: "Warning", type: "alert", content: "Please select production month!", afterClose : enabledButton });
            disabledButton();
        }
         else
         {

            if (GridPOApporval.GetPageCount()>0){  
                disabledButton();
                $.ajax(
                        {
                            type: "POST",
                            url: "@Url.Content("~/D31203/exportToExcel")",
                            data:
                            {
                                PO_MONTH : GetProductionMonth(PO_MONTH.GetValue()),
                                PO_NO : PO_NO.GetText(),
                                PODATE1 : PODate1.GetText(),
                                PODATE2 : PODate2.GetText(),
                                PO_STATUS : PO_STATUS.GetText()
                
                          },
                            success: function (result) {
                                //var link = "@Url.Content("~/")"+result.excelLink;
                                //window.location = link;
                                if (result.excelLink == 'Data not found'){
                                    //MessageBox(result.excelLink,'warning_icon.png','Warning',200);
                                    $.msgBox({ title: "Warning", type: "alert", content: result.excelLink, afterClose : enabledButton });
                                    enabledButton();
                        
                                }else
                                {
                                    var link = "@Url.Content("~/")"+result.excelLink;
                                    window.location = link;
                                    enabledButton();
                                }

                            },
                            error: function (result) {
                                //MessageBox(result.excelLink,'warning_icon.png','Warning',200);
                                $.msgBox({ title: "Warning", type: "alert", content: result.excelLink, afterClose : enabledButton });
                               enabledButton();
                            }
                        });

            }else{
                 //MessageBox('No data for download, make sure data displayed on grid!','warning_icon.png','Warning',280);
                 $.msgBox({ title: "Warning", type: "alert", content: "No data for download, make sure data displayed on grid!", afterClose : enabledButton });
            }

          
         }    
    }
    //---------------------------------------------------------------------------------------------------------

    function OnPOClick(s, e) {
    if (s != '') {
            PO_NO_DET.SetText(s);
            gridmonPopupPODetail.ClearFilter();
            monPopupPO.SetHeaderText('Purchase Order Detail');
            monPopupPO.Show();
            BeginCallbackPOHead(s, e);
    } else {
           popupInformation.Show();
        }
    }
    
    function OnPOBackClick(s, e) {        
        monPopupPO.Hide();
    }

    function BeginCallbackPOHead(s, e) {

        PO_DATE_DET.SetText("");
        PO_LP_DET.SetText("");
        PO_STATUS_DET.SetText("");
        PO_CURR_DET.SetText("");
              
          $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31203/PopupDetailPOHeader")",
                data:
                {
               
                    PO_NO : s
                         
              },
             success: function (result) {

                $.each(result, function (index, item) {
                    if (item) {
                        PO_DATE_DET.SetText(item.CREATED_DT);
                        PO_LP_DET.SetText(item.LOG_PARTNER_NAME);
                        PO_STATUS_DET.SetText(item.PO_STATUS_FLAG);
                        PO_CURR_DET.SetText(item.PO_CURR);
                    }
                });                                      
            },
            error: function (result) {
                //alert("Data not exist");
                $.msgBox({ title: "Warning", type: "alert", content: "Data not exist", afterClose : enabledButton });
            }
        });
    }

    function OnBeginCallbackGridPODetail(s, e) {
        e.customArgs["pPO_NO_DET"] = PO_NO_DET.GetText();
    }

    function GridPOApporval_SelectionChange(s, e) {
        
        if (!is_Bypass) {
            var GridId = OrderSelectionLabel.GetValue();
            var existingList = [];
            var mark = true;

                if (GridId != '') {
                    existingList = GridId.split(';');
                    var len = existingList.length-1;
                    for(var i=0; i<len;i++){
                        if (GridPOApporval.lastMultiSelectIndex == existingList[i].split(',')[0]) {
                            mark = false;
                            existingList[i] = "";
                        }
                    }
                } else {

                    GridId += GridPOApporval.lastMultiSelectIndex + "," +
                    GridPOApporval.cpPROD_MONTH[(GridPOApporval.lastMultiSelectIndex - (GridPOApporval.pageIndex * GridPOApporval.pageRowSize))] + "," +
                    GridPOApporval.cpLP_CD[(GridPOApporval.lastMultiSelectIndex - (GridPOApporval.pageIndex * GridPOApporval.pageRowSize))] + "," +
                    GridPOApporval.cpPO_NO[(GridPOApporval.lastMultiSelectIndex - (GridPOApporval.pageIndex * GridPOApporval.pageRowSize))]+ ";";
                    existingList = GridId.split(';');
                }
            
            
                if (mark) {
                    if (OrderSelectionLabel.GetValue() != "")

                        existingList[(existingList.length-1)] += GridPOApporval.lastMultiSelectIndex + "," +
                                                            
                        GridPOApporval.cpPROD_MONTH[(GridPOApporval.lastMultiSelectIndex - (GridPOApporval.pageIndex * GridPOApporval.pageRowSize))] + "," +
                        GridPOApporval.cpLP_CD[(GridPOApporval.lastMultiSelectIndex - (GridPOApporval.pageIndex * GridPOApporval.pageRowSize))] + "," +
                        GridPOApporval.cpPO_NO[(GridPOApporval.lastMultiSelectIndex - (GridPOApporval.pageIndex * GridPOApporval.pageRowSize))];
                }

                OrderSelectionLabel.SetValue('');
                for(var i=0; i<=(existingList.length-1);i++){
                    if (existingList[i] != "") {
                        OrderSelectionLabel.SetValue(OrderSelectionLabel.GetValue() + existingList[i] + ';');
                    }
                }
        }
    }

   

</script>


<style type="text/css">


#headLegend
 {
     display: block;
     float:left;
     padding: 3px;
     
     border:1px solid #142B94; 
     
     background-color:#DEECFD; 
     width : 170px;
     height: 109px;
     margin-left: 10px;     
 }
 
 .ilegend 
 {
     width: 17px; height: 17px;
     margin-left: 5px;
     margin-right: 5px;
     margin-top : 0px;
     margin-bottom: 0px;
     display: block; 
     float: left;
     clear:none;
 }
 .iwLegendTitle
 {
     height: 25px;
     width: 100%;
     display: block;
     float: left;
     clear: both;
     border-bottom: 1px solid #cfcfff;
     margin-top: 5px;
     margin-bottom: 5px;
 }
 .iwLegend
 {  
     height: 25px;
     width: 80px;
     display: block;
     float: left;
     clear: none;
     margin-top: 5px;
 }
 
 



</style>
<table border="0">
    <tr>

        @*Button*@
        <td>
            <div style="display: table; border: 1px solid #002D96; background-color: #DEECFD; padding: 10px; width:942px; margin-right:10px;">
               @Html.Action("PartialHeader", "D31203")

            </div>
        </td>

        <td valign="top">
            
                <div id="headLegend">
                    <div class="iwLegendTitle">Status Legend</div>
                    <div class="iwLegend"><img src="@Url.Content("~/Content/Images/yellow_1.png")" class="ilegend" /> Pending</div>
                    <div class="iwLegend"><img src="@Url.Content("~/Content/Images/Green_1.png")" class="ilegend" /> Approved</div>
                    <div class="iwLegend"><img src="@Url.Content("~/Content/Images/red.png")" class="ilegend" /> Rejected</div>
                    <div class="iwLegend"><img src="@Url.Content("~/Content/Images/gray.png")" class="ilegend" /> Skip</div>
                </div>
            
        </td>
    </tr>
</table>


<br />
<div style="height: 10px;">
</div>
@* div spacing *@
<div id="grid" style="width:1142px">
    @Html.Action("PartialDatas", "D31203")
</div>


@Html.DevExpress().Label(
label => {
    label.Name = "OrderSelectionLabel";
    label.ClientVisible = false;
        
}).GetHtml()

@Html.DevExpress().PopupControl(settings => {
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Name = "popupInformation";
    settings.HeaderText = "Information";
    
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(250);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(40);
    settings.SetContent(() => {
        Html.RenderPartial("PopupInformation", null);
    });
}).GetHtml()



@Html.DevExpress().PopupControl(settings => {
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Name = "popupError";
    settings.HeaderText = "Error";
    
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(250);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(40);
    settings.SetContent(() => {
        Html.RenderPartial("PopupError", null);
    });
}).GetHtml()


 @Html.DevExpress().PopupControl(settings =>
        {
            settings.Name = "monPopupPO";
            settings.Width = System.Web.UI.WebControls.Unit.Pixel(650);
            settings.Height = System.Web.UI.WebControls.Unit.Pixel(585);
            settings.ScrollBars = ScrollBars.Vertical;
            //settings.Width = System.Web.UI.WebControls.Unit.Percentage(40);
            //settings.Height = System.Web.UI.WebControls.Unit.Percentage(100);
            settings.Modal = true;
            settings.ShowCloseButton = false;
            settings.Top = 35;
            settings.CloseAction = CloseAction.CloseButton;
            settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
            //settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
            //settings.DragElement = DragElement.Window;
            //settings.ShowHeader = false;
            settings.SetContent(() =>
            {
                Html.RenderPartial("monPopupPO");
            });
        }).GetHtml()

@*MESSAGE BOX*@
@Html.Action("MessageBox", "D31203")